#include "plc_vars.h"
#include "common_def.h"

const uint64_t retain_unique_id = 0x4538A40D729F6207UL;
const uint64_t retain_unique_id_old = 0x0UL;


#define _PLC_VAR_LIST \
_PLC_VAR_DEF(retain_unique_id,alias_retain_unique_id,_DIRECT,RETAIN(0,0),NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,Axis_0),default_resource_Axis_0,_SYS,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A1),default_resource_A1,_NORMAL,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.EN,Mast_Main_1_MC_POWER_1_FB_EN,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.ENO,Mast_Main_1_MC_POWER_1_FB_ENO,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.Enable,Mast_Main_1_MC_POWER_1_FB_Enable,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.Axis,Mast_Main_1_MC_POWER_1_FB_Axis,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.EnablePossive,Mast_Main_1_MC_POWER_1_FB_EnablePossive,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.EnableNegative,Mast_Main_1_MC_POWER_1_FB_EnableNegative,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.Status,Mast_Main_1_MC_POWER_1_FB_Status,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.Valid,Mast_Main_1_MC_POWER_1_FB_Valid,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.Error,Mast_Main_1_MC_POWER_1_FB_Error,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_POWER_1.ErrorID,Mast_Main_1_MC_POWER_1_FB_ErrorID,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.EN,Mast_Main_1_MC_JOG_1_FB_EN,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.ENO,Mast_Main_1_MC_JOG_1_FB_ENO,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Velocity,Mast_Main_1_MC_JOG_1_FB_Velocity,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Acceleration,Mast_Main_1_MC_JOG_1_FB_Acceleration,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Deceleration,Mast_Main_1_MC_JOG_1_FB_Deceleration,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Jog,Mast_Main_1_MC_JOG_1_FB_Jog,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Axis,Mast_Main_1_MC_JOG_1_FB_Axis,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Jerk,Mast_Main_1_MC_JOG_1_FB_Jerk,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Done,Mast_Main_1_MC_JOG_1_FB_Done,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Busy,Mast_Main_1_MC_JOG_1_FB_Busy,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.CommandAborted,Mast_Main_1_MC_JOG_1_FB_CommandAborted,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.Error,Mast_Main_1_MC_JOG_1_FB_Error,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.MC_JOG_1.ErrorID,Mast_Main_1_MC_JOG_1_FB_ErrorID,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.JOG1,Mast_Main_1_JOG1_BOOL,_NORMAL,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Mast_Main_1.JOGV,Mast_Main_1_JOGV_REAL,_NORMAL,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.EN,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_EN,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.ENO,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_ENO,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.Axis,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_Axis,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.Enable,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_Enable,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.Done,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_Done,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.Busy,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_Busy,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.CommandAborted,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_CommandAborted,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.Error,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_Error,_DIRECT,NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(Stop1_Stop_interPUT_1.MC_IMMEDIATESTOP_1.ErrorID,Stop1_Stop_interPUT_1_MC_IMMEDIATESTOP_1_FB_ErrorID,_DIRECT,NONRETAIN,NO_TAG) \


#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag)   Alias,
enum PlcVarIndex
{
    _PLC_VAR_LIST
    kNumOfPlcVarIndex
};
#undef _PLC_VAR_DEF

#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag) _MONITOR_VAR(Var,Locate)
const MonitorVarDesc var_list[] = 
{
    _PLC_VAR_LIST
};
const uint32_t var_list_size = sizeof(var_list)/sizeof(var_list[0]);
#undef _PLC_VAR_DEF

#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag)   _RETAN_VAR(Alias,Retain)
const RetainVarDesc retain_list[] = 
{
    _PLC_VAR_LIST
};
const uint32_t retain_list_size = sizeof(retain_list)/sizeof(retain_list[0]);
#undef _PLC_VAR_DEF

#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag)   _TAG_VAR(Alias,Tag)
const TagVarDesc tag_list[] = 
{
    _PLC_VAR_LIST
};
const uint32_t tag_list_size = sizeof(tag_list)/sizeof(tag_list[0]);
#undef _PLC_VAR_DEF

