
PROGRAM Main
  VAR
    MC_Power_1 : MC_Power;
    MC_Jog_1 : MC_Jog;
    JOG1 : BOOL;
    JOGV : REAL;
  END_VAR
  VAR_EXTERNAL
    Axis_0 : AXIS_REF; (*Axis_0_Hsp*)
  END_VAR

  MC_Power_1(EN := TRUE, Axis := Axis_0, Enable := TRUE);
  MC_Jog_1(EN := TRUE, Axis := Axis_0, Jog := JOG1, Velocity := JOGV, Acceleration := 10000.0, Deceleration := 10000.0);
END_PROGRAM

PROGRAM Stop_interPUT
  VAR
    MC_ImmediateStop_1 : MC_ImmediateStop;
  END_VAR
  VAR_EXTERNAL
    Axis_0 : AXIS_REF; (*Axis_0_Hsp*)
  END_VAR

  MC_ImmediateStop_1(EN := TRUE, Axis := Axis_0);
END_PROGRAM

CONFIGURATION config

  RESOURCE default_resource ON PLC
    VAR_GLOBAL
      Axis_0 : AXIS_REF := 0; (*Axis_0_Hsp*)
    END_VAR
    VAR_GLOBAL
      A1 : BOOL;
    END_VAR
    TASK Mast(INTERVAL := t#5ms, PRIORITY := 15);
    TASK Stop1(SINGLE := A1, TRIGGER := 'R_TRIG', PRIORITY := 0);
    PROGRAM Mast_Main_1 WITH Mast : Main;
    PROGRAM Stop1_Stop_interPUT_1 WITH Stop1 : Stop_interPUT;
  END_RESOURCE
END_CONFIGURATION
